import { jsxs as d, jsx as n } from "react/jsx-runtime";
import { useRef as S, useState as k, useEffect as E } from "react";
import M from "../../hooks/useUploadFiles.js";
import w from "../Icons.js";
import { cn as x } from "../../utils/functions.js";
import { c as z } from "../../index-XXb8XwCi.js";
import I from "./CircleProgressLoading.js";
import "../../axios-f2q_J-wz.js";
import "../../clsx-7d8NmkQq.js";
import "../../utils/components/RenderEach.js";
import "../../utils/components/RenderIf.js";
import "./variants.js";
import "../../index-xVF7D3FM.js";
import "../../motion-dVICNqWI.js";
import "../../SVGVisualElement-aqO4D4Z5.js";
import "../../LayoutGroupContext-3euHzeKi.js";
const Q = ({ multiple: p, inputProps: f, setValue: s, currentId: c, fieldError: o, triggerValidation: h, baseURL: u, label: v }) => {
  const { handleUploadImage: N, loadingProgress: y } = M(), _ = S(null), [r, g] = k([]), F = (t, l = 2) => {
    if (t === 0)
      return "0 Bytes";
    const e = 1024, i = l < 0 ? 0 : l, a = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"], m = Math.floor(Math.log(t) / Math.log(e));
    return parseFloat((t / Math.pow(e, m)).toFixed(i)) + " " + a[m];
  }, B = () => {
    _.current && (_.current.value = null);
  }, b = (t) => {
    const l = r.filter((e) => e.id !== t);
    g(l), s(c, l), h(c);
  }, C = async (t) => {
    const l = [];
    for (let e = 0; e < t.target.files.length; e++) {
      const i = t.target.files[e];
      try {
        const a = await N(u, i);
        l.push({
          id: `file_${Date.now()}_${e}`,
          ...a,
          filename: i.name,
          filetype: i.type,
          datetime: i.lastModifiedDate.toLocaleString("en-IN"),
          filesize: F(i.size),
          fileimage: i.fileimage
        });
      } catch (a) {
        console.error("Error uploading file:", a);
      }
    }
    g((e) => [...e, ...l]), s(c, [...r, ...l]), h(c);
  };
  return E(() => {
    B();
  }, [r]), /* @__PURE__ */ d("div", { className: x("_flex _flex-col _rounded-md"), "data-id": "input-wrapper", children: [
    /* @__PURE__ */ n("label", { className: x("_font-main _text-common _text-input"), children: v }),
    /* @__PURE__ */ d("div", { className: "_flex", children: [
      /* @__PURE__ */ d("label", { className: "_relative _inline-block _cursor-pointer _overflow-hidden _rounded-l-md _bg-primary _px-4 _py-2 _text-white _outline-none", children: [
        "Seleccionar archivo",
        /* @__PURE__ */ n("input", { ...f, ref: _, type: "file", className: "_hidden", multiple: p, onChange: C })
      ] }),
      /* @__PURE__ */ n(
        "input",
        {
          type: "text",
          value: r && r.length > 0 ? `${r.length} archivo(s)` : "No hay archivo seleccionado",
          className: "_flex-grow _rounded-r-md _border _border-gray-300 _px-4 _py-2 _outline-none",
          readOnly: !0
        }
      )
    ] }),
    r && r.map((t) => {
      const { id: l, filename: e, fileimage: i, downloadUrl: a, filesize: m } = t;
      return console.log("fileImage"), console.log(i), /* @__PURE__ */ d("div", { className: "_mt-4 _flex _items-center", children: [
        /* @__PURE__ */ n(I, { value: y }),
        /* @__PURE__ */ d("div", { className: "_ml-4 _flex _w-[full] _flex-col _overflow-hidden", children: [
          /* @__PURE__ */ n("p", { className: "_truncate", children: e }),
          /* @__PURE__ */ d("span", { children: [
            "Peso: ",
            m
          ] })
        ] }),
        /* @__PURE__ */ n("a", { className: "_cursor-pointer _mx-4", onClick: () => R(`${u}${a}`, e), title: "Descargar", children: /* @__PURE__ */ n(w.SaveIcon, { className: "_h-6 _w-6" }) }),
        /* @__PURE__ */ n("span", { title: "Eliminar", children: /* @__PURE__ */ n(w.DeleteFile, { className: "_fill-red-500 _h-4 _w-4 _cursor-pointer", onClick: () => b(l) }) })
      ] }, l);
    }),
    /* @__PURE__ */ n(z, { message: o })
  ] });
};
function R(p, f) {
  fetch(p).then((s) => s.blob()).then((s) => {
    const c = window.URL.createObjectURL(new Blob([s])), o = document.createElement("a");
    o.href = c, o.setAttribute("download", f || ""), document.body.appendChild(o), o.click(), o && o.parentNode && o.parentNode.removeChild(o);
  });
}
export {
  Q as default
};
